<?php

namespace xenarabia\BestAnswer;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerInstallTrait;
use XF\AddOn\StepRunnerUninstallTrait;
use XF\AddOn\StepRunnerUpgradeTrait;

use XF\Db\Schema\Alter;
use XF\Db\Schema\Create;

class Setup extends AbstractSetup
{
	use StepRunnerInstallTrait;
	use StepRunnerUpgradeTrait;
	use StepRunnerUninstallTrait;

	public function installStep1()
	{
		$this->schemaManager()->alterTable('xf_thread', function(Alter $table)
		{
			$table->addColumn('xena_post_ba', 'int', 255)->setDefault(0);
			$table->addColumn('xena_userid_ba', 'int')->setDefault(0);
		});
	}

	public function installStep2()
	{
		$this->createWidget(

            'BA_last10questios',
            'BA_Latest10Questions',
            [
                'positions' => [
                    'forum_list_sidebar' => 100
                ]
            ]

		);
		
		$this->createWidget(

            'BA_total_answers_widget_key',
            'BA_total_answers',
            [
                'positions' => [
                    'forum_view_sidebar' => 101
                ]
            ]

		);
		
		$this->createWidget(

            'BA_most_user_answers_widget_key',
            'BA_most_user_answers',
            [
                'positions' => [
                    'forum_view_sidebar' => 102
                ]
            ]

		);
		
		$this->createWidget(

            'BA_last_answers_widget_key',
            'BA_Latest_answers',
            [
                'positions' => [
                    'forum_view_sidebar' => 103
                ]
            ]

        );
	}

	public function upgrade1000020Step1(array $stepParams = [])
	{
		$this->schemaManager()->alterTable('xf_thread', function(Alter $table)
		{
			$table->addColumn('xena_post_ba', 'int', 255)->setDefault(0);
			$table->addColumn('xena_userid_ba', 'int')->setDefault(0);
		});
	}
	
	

	public function upgrade1000030Step1(array $stepParams = [])
	{
		$this->schemaManager()->alterTable('xf_thread', function(Alter $table)
		{
			$table->addColumn('xena_post_ba', 'int', 255)->setDefault(0);
			$table->addColumn('xena_userid_ba', 'int')->setDefault(0);
		});
	}
	

	public function upgrade1000042Step1(array $stepParams = [])
	{
		$this->createWidget(

            'BA_last10questios',
            'BA_Latest10Questions',
            [
                'positions' => [
                    'forum_list_sidebar' => 100
                ]
            ]

		);
		
		$this->createWidget(

            'BA_total_answers_widget_key',
            'BA_total_answers',
            [
                'positions' => [
                    'forum_view_sidebar' => 101
                ]
            ]

		);
		
		$this->createWidget(

            'BA_most_user_answers_widget_key',
            'BA_most_user_answers',
            [
                'positions' => [
                    'forum_view_sidebar' => 102
                ]
            ]

		);
		
		$this->createWidget(

            'BA_last_answers_widget_key',
            'BA_Latest_answers',
            [
                'positions' => [
                    'forum_view_sidebar' => 103
                ]
            ]

        );
		
	}

	public function uninstall(array $stepParams = [])
	{
		$this->schemaManager()->alterTable('xf_thread', function(Alter $table)
		{
			$table->dropColumns('xena_post_ba', 'varchar');
			$table->dropColumns('xena_userid_ba', 'int');
		});
	}
}